{{servo_objects_15.spin 1-19-08 1801}}
{left wheel - 12, right wheel 13}

obj

  compass : "Sensor.HM55B.Compass"
  Debug   : "Debug_Lcd"
  
  
var

  long Pause, Pulsout, Count, CurrentHeading

pub RightForward(EndCount)            'right wheel forward(for this amount of time, 0 = inf)

  Count := 0                          'you haven't gone anywhere yet
  Pause := clkfreq/1_000              'set pause length
  Pulsout := clkfreq/500_000          'set pulsout length
  dira[12]~~                          'set pin 12 to output
  outa[12]~                           'set pin 12 low

  if EndCount > 0                     'if you want to move for a certain amount of time
    repeat Count from 0 to EndCount   'pulse servos until you've gone as far as you need to 
      outa[12]~~
      waitcnt(Pulsout * 650 + cnt)

      outa[12]~
      waitcnt(Pause * 20 + cnt)

  else
    repeat                             'pulse servos forever
      outa[12]~~
      waitcnt(Pulsout * 650 + cnt)

      outa[12]~
      waitcnt(Pause * 20 + cnt)


pub RightBackward(EndCount)           'right wheel backward(for this amount of time, 0 = inf)

  Count :=0                           'you haven't gone anywhere yet
  Pause := clkfreq/1_000              'set pause length
  Pulsout := clkfreq/500_000          'set pulsout length
  dira[12]~~                          'set pin 12 to output
  outa[12]~                           'set pin 12 low

  if EndCount > 0                     'if you want to move for a certain amount of time
    repeat Count from 0 to EndCount   'pulse servos until you've gone as far as you need
      outa[12]~~
      waitcnt(Pulsout * 850 + cnt)
     
      outa[12]~
      waitcnt(Pause * 20 + cnt)
  else                                 'if you want to go inf
    repeat                             'pulse servos forever...
      outa[12]~~
      waitcnt(Pulsout * 850 + cnt)

      outa[12]~
      waitcnt(Pause * 20 + cnt)

pub RightStop                           'stop right wheel

  Pause := clkfreq/1_000
  Pulsout := clkfreq/500_000
  dira[12]~~
  outa[12]~

  repeat                                 'tell servos to stop
    outa[12]~~                           
    waitcnt(Pulsout * 750 + cnt)
   
    outa[12]~
    waitcnt(Pause * 20 + cnt)     
   


pub LeftForward(EndCount)                 'left wheel forward(for this amount of time, 0 = inf)

  Count := 0
  Pause := clkfreq/1_000
  Pulsout := clkfreq/500_000
  dira[13]~~
  outa[13]~

  if EndCount > 0
    repeat Count from 0 to EndCount 
      outa[13]~~
      waitcnt(Pulsout * 850 + cnt)
       
      outa[13]~
      waitcnt(Pause * 20 + cnt)
  else
    repeat
      outa[13]~~
      waitcnt(Pulsout * 850 + cnt)

      outa[13]~
      waitcnt(Pause * 20 + cnt)
             
pub LeftBackward(EndCount)                 'left wheel backward(for this amount of time, 0 = inf)

  Count :=0
  Pause := clkfreq/1_000
  Pulsout := clkfreq/500_000
  dira[13]~~
  outa[13]~

  if EndCount > 0
    repeat Count from 0 to EndCount
      outa[13]~~
      waitcnt(Pulsout * 650 + cnt)
       
      outa[13]~
      waitcnt(Pause * 20 + cnt)
  else
    repeat
      outa[13]~~
      waitcnt(Pulsout * 650 + cnt)

      outa[13]~
      waitcnt(Pause * 20 + cnt)

             

pub LeftStop                                 'tell left servo to stop

  Pause := clkfreq/1_000
  Pulsout := clkfreq/500_000
  dira[13]~~
  outa[13]~

  repeat
    outa[13]~~
    waitcnt(Pulsout * 750 + cnt)
     
    outa[13]~
    waitcnt(Pause * 20 + cnt)


pub AllForward(EndCount)          'left wheel counterclockwise, right wheel clockwise(for this amount of time, 0 = inf)

  Pause := clkfreq/1_000
  Pulsout := clkfreq/500_000
  Count := 0
  dira[12..13]~~
  outa[12..13]~

  if EndCount > 0
    repeat Count from 0 to EndCount
      outa[12]~~
      waitcnt(Pulsout * 650 + cnt)
      outa[12]~
       
      outa[13]~~
      waitcnt(Pulsout * 850 + cnt)
      outa[13]~
       
      waitcnt(Pause * 20 + cnt)
  else
    repeat
      outa[12]~~
      waitcnt(Pulsout * 650 + cnt)
      outa[12]~

      outa[13]~~
      waitcnt(Pulsout * 850 + cnt)
      outa[13]~

      waitcnt(Pause * 20 + cnt)

             
pub AllBackward(EndCount)        'left wheel clockwise, right wheel counterclockwise(for this amount of time, 0 = inf)

  Pause := clkfreq/1_000
  Pulsout:= clkfreq/500_000
  Count := 0
  dira[12..13]~~
  outa[12..13]~

  if EndCount > 0
    repeat Count from 0 to EndCount
      outa[12]~~
      waitcnt(Pulsout * 850 + cnt)
      outa[12]~
       
      outa[13]~~
      waitcnt(Pulsout * 650 + cnt)
      outa[13]~
       
      waitcnt(Pause * 20 + cnt)
  else
    repeat
      outa[12]~~
      waitcnt(Pulsout * 850 + cnt)
      outa[12]~

      outa[13]~~
      waitcnt(Pulsout * 650 + cnt)
      outa[13]~

      waitcnt(Pause * 20 + cnt)
      
     
pub AllStop                           'tell both wheels to stop

  Pause := clkfreq/1_000
  Pulsout := clkfreq/500_000
  dira[12..13]~~
  outa[12..13]~

  repeat
    outa[12..13]~~
    waitcnt(Pulsout * 750 + cnt)

    outa[12..13]~
    waitcnt(Pause * 20 + cnt)

pub TankRight(EndCount)             'right wheel forward, left wheel backward(for this amount of time, 0 = inf)

  Pause :=clkfreq/1_000
  Pulsout := clkfreq/500_000
  Count := 0
  dira[12..13]~~
  outa[12..13]~

  if EndCount > 0
    repeat Count from 0 to EndCount
      outa[12..13]~~
      waitcnt(pulsout * 850 + cnt)
   
      outa[12..13]~
      waitcnt(Pause * 20 + cnt)

  else
    repeat
      outa[12..13]~
      waitcnt(Pulsout * 850 + cnt)

      outa[12..13]~
      waitcnt(Pause * 20 + cnt)
   
pub TankLeft(EndCount)           'left wheel forward, right wheel backward(for this amount of time, 0 = inf)

  Pause := clkfreq/1_000
  Pulsout := clkfreq/500_000
  Count := 0
  dira[12..13]~~
  outa[12..13]~

  if EndCount > 0
    repeat Count from 0 to EndCount
      outa[12..13]~~
      waitcnt(Pulsout * 650 + cnt)
     
      outa[12..13]~
      waitcnt(Pause * 20 + cnt)

  else
    repeat
      outa[12..13]~~
      waitcnt(Pulsout * 650 + cnt)

      outa[12..13]~
      waitcnt(Pause * 20 + cnt)   